;********************************************************
;              THYRISTORS CONTROLLER
;
;                                 DEVICE : PIC16F84
;********************************************************

        LIST            P=PIC16F84
        INCLUDE         P16F84.INC
        ERRORLEVEL      -302    ;SUPPRESS BANK WARNING

;****************  LABEL DEFINITION  ********************
CONT    EQU      H'11'
CONT1   EQU      H'13'
SKOR    EQU      H'15'
W_COPY  EQU      H'17'
ST_COPY EQU      H'19'
CON     EQU      H'1B'
REG     EQU      H'1D'
SIP     EQU      H'1F'
MOP     EQU      H'1C'
;****************  PROGRAM START  ***********************
        ORG     0               ;RESET VECTOR
        GOTO    INIT
        ORG     4               ;INTERRUPT VECTOR
        GOTO    PRER

;****************  INITIAL PROCESS  *********************
INIT

;*** PORT INITIALIZATION
        BSF     STATUS,RP0      ;CHANGE TO BANK1
        MOVLW   B'00011111'     ;AN0 TO INPUT MODE
        MOVWF   TRISA           ;SET TRISA REGISTER
        MOVLW   B'00001001'
        MOVWF   TRISB      
        MOVLW   B'01000000'
        MOVWF   OPTION_REG
        BCF     STATUS,RP0      ;CHANGE TO BANK0
        CLRF    PORTB
        CLRF    PORTA
        CLRF    REG
        CLRF    MOP
        BSF     MOP,2
        MOVLW   B'11111100'
        MOVWF   SKOR
        MOVLW   B'11111011'
        MOVWF   SIP
        MOVLW   B'10010000'
        MOVWF   INTCON
;*** INTERRUPTION CONTROL
ZOTKIN  NOP
        BCF     PORTB,5
        MOVLW   B'11111100'
        BTFSC   PORTA,1
        MOVWF   SKOR
        BTFSC   PORTA,2
        GOTO    ED
        GOTO    JN
        GOTO    ZOTKIN
JN      CALL    SDD
        MOVFW   SKOR 
        SUBWF   SIP,0
        BTFSC   STATUS,C
        GOTO    IP
        GOTO    ZOTKIN1
IP      MOVFW   SKOR
        ADDLW   B'00000001'
        MOVWF   SKOR
UP      GOTO    ZOTKIN
ED      CALL    SDD1
        MOVLW   B'00000010'         
        SUBWF   SKOR,0        
        BTFSC   STATUS,C        
        GOTO    RR
        MOVLW   B'00000001'
        MOVWF   SKOR
        GOTO    YU
RR      MOVLW   B'00000001'
        SUBWF   SKOR,1
YU      GOTO    ZOTKIN
;*** INTERRUPTION  PROCESS
PRER    MOVWF   W_COPY
        SWAPF   STATUS,W
        MOVWF   ST_COPY
        CLRF    REG
        BCF     PORTB,2
        BCF     PORTB,4
        BCF     PORTB,6
        BCF     PORTB,1
        BTFSS   PORTB,3
        GOTO    UPP
        BSF     REG,1
UPP     MOVLW   B'00000010'
        MOVWF    CON
H3      CLRWDT
        DECFSZ   CON,1
        GOTO     H3
        MOVFW   SKOR
        MOVWF    CON
H2      CLRWDT
        DECFSZ   CON,1
        GOTO     H2
        SWAPF   ST_COPY,W
        MOVWF   STATUS
        SWAPF   W_COPY,F
        SWAPF   W_COPY,W
        BCF     INTCON,INTF
        RETFIE       
SDD     MOVLW    .030
        MOVWF    CONT
HH      CLRWDT
        CALL     RAV
        DECFSZ   CONT,1
        GOTO     HH
        CLRW
        RETURN      
SDD1    MOVLW    .030
        MOVWF    CONT
HH5     CLRWDT
        CALL     RAV
        DECFSZ   CONT,1
        GOTO     HH5
        CLRW
        RETURN      
RAV     BTFSS    PORTB,3
        GOTO     PER
        BTFSS    REG,1
        GOTO     PER
        BSF      PORTB,2
        MOVLW    .005
        MOVWF    CONT1
V       CLRWDT
        DECFSZ   CONT1,1
        GOTO     V
        BCF      PORTB,2
        GOTO     PER1
PER     NOP
        BTFSS    PORTB,3
        GOTO     MAL
        GOTO     PER1
MAL     BTFSC    REG,1
        GOTO     PER1
        BSF      PORTB,6
        MOVLW    .005
        MOVWF    CONT1
V2      CLRWDT
        DECFSZ   CONT1,1
        GOTO     V2
        BCF      PORTB,6
PER1    RETURN                                  
ZOTKIN1 NOP
        BSF     PORTB,5
        MOVLW   B'11111100'
        BTFSC   PORTA,1
        MOVWF   SKOR
        BTFSC   PORTA,2
        GOTO    JN1
        GOTO    ED1
        GOTO    ZOTKIN1
JN1     CALL    ASDD
        MOVFW   SKOR 
        SUBWF   SIP,0
        BTFSC   STATUS,C
        GOTO    AIP
        GOTO    ZOTKIN
AIP     MOVFW   SKOR
        ADDLW   B'00000001'
        MOVWF   SKOR
AUP     GOTO    ZOTKIN1
ED1     CALL    ASDD1
        MOVLW   B'00000010'         
        SUBWF   SKOR,0        
        BTFSC   STATUS,C        
        GOTO    ARR
        MOVLW   B'00000001'
        MOVWF   SKOR
        GOTO    AYU
ARR     MOVLW   B'00000001'
        SUBWF   SKOR,1
AYU     GOTO    ZOTKIN1
ASDD    MOVLW    .030
        MOVWF    CONT
AHH     CLRWDT
        CALL     ARAV
        DECFSZ   CONT,1
        GOTO     AHH
        CLRW
        RETURN      
ASDD1   MOVLW    .030
        MOVWF    CONT
AHH5    CLRWDT
        CALL     ARAV
        DECFSZ   CONT,1
        GOTO     AHH5
        CLRW
        RETURN      
ARAV    BTFSS    PORTB,3
        GOTO     APERP
        GOTO     APER
APERP   BTFSC    REG,1
        GOTO     APER
        BSF      PORTB,4
        MOVLW    .005
        MOVWF    CONT1
AV1     CLRWDT
        DECFSZ   CONT1,1
        GOTO     AV1
        BCF      PORTB,4
        GOTO     APER1
APER    NOP
        BTFSS    PORTB,3
        GOTO     APER1
        BTFSS    REG,1
        GOTO     APER1
        BSF      PORTB,1
        MOVLW    .005
        MOVWF    CONT1
AV2     CLRWDT
        DECFSZ   CONT1,1
        GOTO     AV2
        BCF      PORTB,1
APER1   RETURN                                  
        END
        
